/* PopoverWidget.c generated by valac 0.56.13, the Vala compiler
 * generated from PopoverWidget.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "power.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	POWER_WIDGETS_POPOVER_WIDGET_0_PROPERTY,
	POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY,
	POWER_WIDGETS_POPOVER_WIDGET_NUM_PROPERTIES
};
static GParamSpec* power_widgets_popover_widget_properties[POWER_WIDGETS_POPOVER_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerWidgetsPopoverWidgetPrivate {
	gboolean _is_in_session;
	PowerWidgetsAppList* app_list;
	GtkRevealer* device_separator_revealer;
};

struct _Block7Data {
	int _ref_count_;
	PowerWidgetsPopoverWidget* self;
	GtkRevealer* last_separator_revealer;
};

static gint PowerWidgetsPopoverWidget_private_offset;
static gpointer power_widgets_popover_widget_parent_class = NULL;
static PowerServicesDeviceManager* power_widgets_popover_widget_dm;
static PowerServicesDeviceManager* power_widgets_popover_widget_dm = NULL;

static void power_widgets_popover_widget_update_device_seperator_revealer (PowerWidgetsPopoverWidget* self);
static GObject * power_widgets_popover_widget_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _power_widgets_popover_widget___lambda23_ (PowerWidgetsPopoverWidget* self,
                                                GObject* s,
                                                GParamSpec* p);
static void __power_widgets_popover_widget___lambda23__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _power_widgets_popover_widget___lambda24_ (PowerWidgetsPopoverWidget* self);
static void __power_widgets_popover_widget___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _power_widgets_popover_widget___lambda25_ (Block7Data* _data7_,
                                                gint brightness);
static void __power_widgets_popover_widget___lambda25__power_services_device_manager_brightness_changed (PowerServicesDeviceManager* _sender,
                                                                                                  gint brightness,
                                                                                                  gpointer self);
static void power_widgets_popover_widget_finalize (GObject * obj);
static GType power_widgets_popover_widget_get_type_once (void);
static void _vala_power_widgets_popover_widget_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_power_widgets_popover_widget_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
power_widgets_popover_widget_get_instance_private (PowerWidgetsPopoverWidget* self)
{
	return G_STRUCT_MEMBER_P (self, PowerWidgetsPopoverWidget_private_offset);
}

PowerWidgetsPopoverWidget*
power_widgets_popover_widget_construct (GType object_type,
                                        gboolean is_in_session)
{
	PowerWidgetsPopoverWidget * self = NULL;
	self = (PowerWidgetsPopoverWidget*) g_object_new (object_type, "is-in-session", is_in_session, NULL);
	return self;
}

PowerWidgetsPopoverWidget*
power_widgets_popover_widget_new (gboolean is_in_session)
{
	return power_widgets_popover_widget_construct (POWER_WIDGETS_TYPE_POPOVER_WIDGET, is_in_session);
}

static void
power_widgets_popover_widget_update_device_seperator_revealer (PowerWidgetsPopoverWidget* self)
{
	gboolean _tmp0_ = FALSE;
	PowerServicesDeviceManager* _tmp1_;
	PowerServicesBacklight* _tmp2_;
	PowerServicesBacklight* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkRevealer* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp1_ = power_widgets_popover_widget_dm;
	_tmp2_ = power_services_device_manager_get_backlight (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = power_services_backlight_get_present (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		PowerServicesDeviceManager* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = power_widgets_popover_widget_dm;
		_tmp7_ = power_services_device_manager_get_has_battery (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp9_ = self->priv->device_separator_revealer;
	gtk_revealer_set_reveal_child (_tmp9_, _tmp0_);
}

void
power_widgets_popover_widget_slim_down (PowerWidgetsPopoverWidget* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_is_in_session;
	if (_tmp0_) {
		PowerWidgetsAppList* _tmp1_;
		_tmp1_ = self->priv->app_list;
		power_widgets_app_list_clear_list (_tmp1_);
	}
}

gboolean
power_widgets_popover_widget_get_is_in_session (PowerWidgetsPopoverWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_in_session;
	return result;
}

static void
power_widgets_popover_widget_set_is_in_session (PowerWidgetsPopoverWidget* self,
                                                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = power_widgets_popover_widget_get_is_in_session (self);
	if (old_value != value) {
		self->priv->_is_in_session = value;
		g_object_notify_by_pspec ((GObject *) self, power_widgets_popover_widget_properties[POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY]);
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		PowerWidgetsPopoverWidget* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->last_separator_revealer);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_power_widgets_popover_widget___lambda23_ (PowerWidgetsPopoverWidget* self,
                                           GObject* s,
                                           GParamSpec* p)
{
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	power_widgets_popover_widget_update_device_seperator_revealer (self);
}

static void
__power_widgets_popover_widget___lambda23__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
	_power_widgets_popover_widget___lambda23_ ((PowerWidgetsPopoverWidget*) self, _sender, pspec);
}

static void
_power_widgets_popover_widget___lambda24_ (PowerWidgetsPopoverWidget* self)
{
	GError* _inner_error0_ = NULL;
	{
		g_app_info_launch_default_for_uri ("settings://power", NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("PopoverWidget.vala:120: Failed to open power settings: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__power_widgets_popover_widget___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
	_power_widgets_popover_widget___lambda24_ ((PowerWidgetsPopoverWidget*) self);
}

static void
_power_widgets_popover_widget___lambda25_ (Block7Data* _data7_,
                                           gint brightness)
{
	PowerWidgetsPopoverWidget* self;
	self = _data7_->self;
	if (brightness != -1) {
		GtkRevealer* _tmp0_;
		_tmp0_ = _data7_->last_separator_revealer;
		gtk_revealer_set_reveal_child (_tmp0_, TRUE);
	} else {
		GtkRevealer* _tmp1_;
		_tmp1_ = _data7_->last_separator_revealer;
		gtk_revealer_set_reveal_child (_tmp1_, FALSE);
	}
}

static void
__power_widgets_popover_widget___lambda25__power_services_device_manager_brightness_changed (PowerServicesDeviceManager* _sender,
                                                                                             gint brightness,
                                                                                             gpointer self)
{
	_power_widgets_popover_widget___lambda25_ (self, brightness);
}

static GObject *
power_widgets_popover_widget_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerWidgetsPopoverWidget * self;
	Block7Data* _data7_;
	GSettings* settings = NULL;
	GSettings* _tmp0_;
	PowerWidgetsDeviceList* device_list = NULL;
	PowerWidgetsDeviceList* _tmp1_;
	GtkRevealer* device_list_revealer = NULL;
	GtkRevealer* _tmp2_;
	GtkRevealer* _tmp3_;
	PowerWidgetsDeviceList* _tmp4_;
	GtkSeparator* device_separator = NULL;
	GtkSeparator* _tmp5_ = NULL;
	GtkRevealer* _tmp6_;
	GtkRevealer* _tmp7_;
	GtkSeparator* _tmp8_;
	GtkSeparator* last_separator = NULL;
	GtkSeparator* _tmp9_ = NULL;
	PowerServicesDeviceManager* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GtkRevealer* _tmp13_ = NULL;
	GtkRevealer* _tmp14_;
	GtkSeparator* _tmp15_;
	GraniteSwitchModelButton* show_percent_switch = NULL;
	GraniteSwitchModelButton* _tmp16_;
	GraniteSwitchModelButton* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkSeparator* show_percent_sep = NULL;
	GtkSeparator* _tmp19_ = NULL;
	GtkBox* show_percent_box = NULL;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GraniteSwitchModelButton* _tmp22_;
	GtkBox* _tmp23_;
	GtkSeparator* _tmp24_;
	GtkRevealer* show_percent_revealer = NULL;
	GtkRevealer* _tmp25_;
	GtkRevealer* _tmp26_;
	GtkBox* _tmp27_;
	GtkModelButton* show_settings_button = NULL;
	gchar* _tmp28_;
	GtkModelButton* _tmp29_ = NULL;
	GtkRevealer* _tmp30_;
	GtkRevealer* _tmp31_;
	GtkRevealer* _tmp32_;
	PowerServicesDeviceManager* _tmp33_;
	PowerServicesBacklight* _tmp34_;
	PowerServicesBacklight* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp40_;
	PowerServicesDeviceManager* _tmp45_;
	GSettings* _tmp46_;
	GraniteSwitchModelButton* _tmp47_;
	PowerServicesDeviceManager* _tmp48_;
	GtkRevealer* _tmp49_;
	gboolean _tmp50_ = FALSE;
	PowerServicesDeviceManager* _tmp51_;
	gboolean _tmp52_;
	gboolean _tmp53_;
	GtkModelButton* _tmp60_;
	PowerServicesDeviceManager* _tmp61_;
	parent_class = G_OBJECT_CLASS (power_widgets_popover_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = g_settings_new ("io.elementary.desktop.wingpanel.power");
	settings = _tmp0_;
	_tmp1_ = power_widgets_device_list_new ();
	g_object_ref_sink (_tmp1_);
	device_list = _tmp1_;
	_tmp2_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp2_);
	device_list_revealer = _tmp2_;
	_tmp3_ = device_list_revealer;
	_tmp4_ = device_list;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp5_, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp5_, 3);
	g_object_ref_sink (_tmp5_);
	device_separator = _tmp5_;
	_tmp6_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->device_separator_revealer);
	self->priv->device_separator_revealer = _tmp6_;
	_tmp7_ = self->priv->device_separator_revealer;
	_tmp8_ = device_separator;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
	_tmp9_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp9_, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp9_, 3);
	g_object_ref_sink (_tmp9_);
	last_separator = _tmp9_;
	_tmp10_ = power_widgets_popover_widget_dm;
	_tmp11_ = power_services_device_manager_get_brightness (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_reveal_child (_tmp13_, _tmp12_ != -1);
	g_object_ref_sink (_tmp13_);
	_data7_->last_separator_revealer = _tmp13_;
	_tmp14_ = _data7_->last_separator_revealer;
	_tmp15_ = last_separator;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = granite_switch_model_button_new (_ ("Show Percentage"));
	g_object_ref_sink (_tmp16_);
	show_percent_switch = _tmp16_;
	_tmp17_ = show_percent_switch;
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
	gtk_style_context_add_class (_tmp18_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp19_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp19_, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp19_, 3);
	g_object_ref_sink (_tmp19_);
	show_percent_sep = _tmp19_;
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp20_);
	show_percent_box = _tmp20_;
	_tmp21_ = show_percent_box;
	_tmp22_ = show_percent_switch;
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = show_percent_box;
	_tmp24_ = show_percent_sep;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp25_);
	show_percent_revealer = _tmp25_;
	_tmp26_ = show_percent_revealer;
	_tmp27_ = show_percent_box;
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = g_strdup (_ ("Power Settings…"));
	_tmp29_ = (GtkModelButton*) gtk_model_button_new ();
	g_object_set (_tmp29_, "text", _tmp28_, NULL);
	_g_free0 (_tmp28_);
	g_object_ref_sink (_tmp29_);
	show_settings_button = _tmp29_;
	_tmp30_ = show_percent_revealer;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp30_, 0, 0, 1, 1);
	_tmp31_ = device_list_revealer;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp31_, 0, 1, 1, 1);
	_tmp32_ = self->priv->device_separator_revealer;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp32_, 0, 3, 1, 1);
	_tmp33_ = power_widgets_popover_widget_dm;
	_tmp34_ = power_services_device_manager_get_backlight (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = power_services_backlight_get_present (_tmp35_);
	_tmp37_ = _tmp36_;
	if (_tmp37_) {
		PowerWidgetsScreenBrightness* screen_brightness = NULL;
		PowerWidgetsScreenBrightness* _tmp38_;
		PowerWidgetsScreenBrightness* _tmp39_;
		_tmp38_ = power_widgets_screen_brightness_new ();
		g_object_ref_sink (_tmp38_);
		screen_brightness = _tmp38_;
		_tmp39_ = screen_brightness;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp39_, 0, 4, 1, 1);
		_g_object_unref0 (screen_brightness);
	}
	_tmp40_ = self->priv->_is_in_session;
	if (_tmp40_) {
		PowerWidgetsAppList* _tmp41_;
		PowerWidgetsAppList* _tmp42_;
		GtkRevealer* _tmp43_;
		GtkModelButton* _tmp44_;
		_tmp41_ = power_widgets_app_list_new ();
		g_object_ref_sink (_tmp41_);
		_g_object_unref0 (self->priv->app_list);
		self->priv->app_list = _tmp41_;
		_tmp42_ = self->priv->app_list;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp42_, 0, 2, 1, 1);
		_tmp43_ = _data7_->last_separator_revealer;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp43_, 0, 5, 1, 1);
		_tmp44_ = show_settings_button;
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp44_, 0, 6, 1, 1);
	}
	power_widgets_popover_widget_update_device_seperator_revealer (self);
	_tmp45_ = power_widgets_popover_widget_dm;
	g_signal_connect_object ((GObject*) _tmp45_, "notify::has-battery", (GCallback) __power_widgets_popover_widget___lambda23__g_object_notify, self, 0);
	_tmp46_ = settings;
	_tmp47_ = show_percent_switch;
	g_settings_bind (_tmp46_, "show-percentage", (GObject*) _tmp47_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp48_ = power_widgets_popover_widget_dm;
	_tmp49_ = device_list_revealer;
	g_object_bind_property_with_closures ((GObject*) _tmp48_, "has-battery", (GObject*) _tmp49_, "reveal-child", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp51_ = power_widgets_popover_widget_dm;
	_tmp52_ = power_services_device_manager_get_has_battery (_tmp51_);
	_tmp53_ = _tmp52_;
	if (_tmp53_) {
		PowerServicesDeviceManager* _tmp54_;
		PowerServicesDevice* _tmp55_;
		PowerServicesDevice* _tmp56_;
		gboolean _tmp57_;
		gboolean _tmp58_;
		_tmp54_ = power_widgets_popover_widget_dm;
		_tmp55_ = power_services_device_manager_get_display_device (_tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = power_services_device_get_is_a_battery (_tmp56_);
		_tmp58_ = _tmp57_;
		_tmp50_ = _tmp58_;
	} else {
		_tmp50_ = FALSE;
	}
	if (_tmp50_) {
		GtkRevealer* _tmp59_;
		_tmp59_ = show_percent_revealer;
		gtk_revealer_set_reveal_child (_tmp59_, TRUE);
	}
	_tmp60_ = show_settings_button;
	g_signal_connect_object ((GtkButton*) _tmp60_, "clicked", (GCallback) __power_widgets_popover_widget___lambda24__gtk_button_clicked, self, 0);
	_tmp61_ = power_widgets_popover_widget_dm;
	g_signal_connect_data (_tmp61_, "brightness-changed", (GCallback) __power_widgets_popover_widget___lambda25__power_services_device_manager_brightness_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_g_object_unref0 (show_settings_button);
	_g_object_unref0 (show_percent_revealer);
	_g_object_unref0 (show_percent_box);
	_g_object_unref0 (show_percent_sep);
	_g_object_unref0 (show_percent_switch);
	_g_object_unref0 (last_separator);
	_g_object_unref0 (device_separator);
	_g_object_unref0 (device_list_revealer);
	_g_object_unref0 (device_list);
	_g_object_unref0 (settings);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return obj;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
power_widgets_popover_widget_class_init (PowerWidgetsPopoverWidgetClass * klass,
                                         gpointer klass_data)
{
	PowerServicesDeviceManager* _tmp0_;
	PowerServicesDeviceManager* _tmp1_;
	power_widgets_popover_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PowerWidgetsPopoverWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_power_widgets_popover_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_power_widgets_popover_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = power_widgets_popover_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = power_widgets_popover_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY, power_widgets_popover_widget_properties[POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = power_services_device_manager_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (power_widgets_popover_widget_dm);
	power_widgets_popover_widget_dm = _tmp1_;
}

static void
power_widgets_popover_widget_instance_init (PowerWidgetsPopoverWidget * self,
                                            gpointer klass)
{
	self->priv = power_widgets_popover_widget_get_instance_private (self);
	self->priv->_is_in_session = FALSE;
}

static void
power_widgets_popover_widget_finalize (GObject * obj)
{
	PowerWidgetsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
	_g_object_unref0 (self->priv->app_list);
	_g_object_unref0 (self->priv->device_separator_revealer);
	G_OBJECT_CLASS (power_widgets_popover_widget_parent_class)->finalize (obj);
}

static GType
power_widgets_popover_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerWidgetsPopoverWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_widgets_popover_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerWidgetsPopoverWidget), 0, (GInstanceInitFunc) power_widgets_popover_widget_instance_init, NULL };
	GType power_widgets_popover_widget_type_id;
	power_widgets_popover_widget_type_id = g_type_register_static (gtk_grid_get_type (), "PowerWidgetsPopoverWidget", &g_define_type_info, 0);
	PowerWidgetsPopoverWidget_private_offset = g_type_add_instance_private (power_widgets_popover_widget_type_id, sizeof (PowerWidgetsPopoverWidgetPrivate));
	return power_widgets_popover_widget_type_id;
}

GType
power_widgets_popover_widget_get_type (void)
{
	static volatile gsize power_widgets_popover_widget_type_id__once = 0;
	if (g_once_init_enter (&power_widgets_popover_widget_type_id__once)) {
		GType power_widgets_popover_widget_type_id;
		power_widgets_popover_widget_type_id = power_widgets_popover_widget_get_type_once ();
		g_once_init_leave (&power_widgets_popover_widget_type_id__once, power_widgets_popover_widget_type_id);
	}
	return power_widgets_popover_widget_type_id__once;
}

static void
_vala_power_widgets_popover_widget_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	PowerWidgetsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
	switch (property_id) {
		case POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY:
		g_value_set_boolean (value, power_widgets_popover_widget_get_is_in_session (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_power_widgets_popover_widget_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	PowerWidgetsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
	switch (property_id) {
		case POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY:
		power_widgets_popover_widget_set_is_in_session (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

